<?php
/*
 +--------------------------------------------------------------------------+
 | phpMyBackupPro                                                           |
 +--------------------------------------------------------------------------+
 | Copyright (c) 2004 by Dirk Randhahn                                      |
 | http://sourceforge.net/projects/phpmybackup/                             |
 | Version information can be found in definitions.php.                     |
 |                                                                          |
 | This program is free software; you can redistribute it and/or            |
 | modify it under the terms of the GNU General Public License              |
 | as published by the Free Software Foundation; either version 2           |
 | of the License, or (at your option) any later version.                   |
 |                                                                          |
 | This program is distributed in the hope that it will be useful,          |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
 | GNU General Public License for more details.                             |
 |                                                                          |
 | You should have received a copy of the GNU General Public License        |
 | along with this program; if not, write to the Free Software              |
 | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.|
 +--------------------------------------------------------------------------+
*/

include("login.php");
include_once("definitions.php");

printHeader(ereg_replace(".*/","",$_SERVER['SCRIPT_NAME']),$CONF['lang']);

// the descriptions and var names
// $conf[C_LANG] must be last
$conf[C_SITENAME]="sitename";
$conf[C_SQL_HOST]="sql_host";
$conf[C_SQL_USER]="sql_user";
$conf[C_SQL_PASSWD]="sql_passwd";
$conf[C_TIMELIMIT]="timelimit";
$conf[C_IMPORT_ERROR]="import_error";
$conf[C_FTP_USE]="ftp_use";
$conf[C_FTP_SERVER]="ftp_server";
$conf[C_FTP_USER]="ftp_user";
$conf[C_FTP_PASSWD]="ftp_passwd";
$conf[C_FTP_PATH]="ftp_path";
$conf[C_FTP_PASV]="ftp_pasv";
$conf[C_EMAIL_USE]="email_use";
$conf[C_EMAIL]="email";
$conf[C_DEL_TIME]="del_time";
$conf[C_CONFIRM]="confirm";
$conf[C_DATE]="date";
$conf[C_LANG]="lang";

$time=time();

// vars whos type is checkbox, password or select
$checkbox=array("ftp_use","ftp_pasv","email_use","import_error");
$password=array("sql_passwd","ftp_passwd");
$select['confirm']=array(C_CONFIRM_1,C_CONFIRM_2,C_CONFIRM_3,C_CONFIRM_4);
$select['date']=array("%x %X"=>strftime("%x %X",$time),"%x %H:%M"=>strftime("%x %H:%M",$time),
    "%m/%d/%y %X"=>strftime("%m/%d/%y %X",$time),"%m/%d/%y %H:%M"=>strftime("%m/%d/%y %H:%M",$time),
    "%b %d %Y %X"=>strftime("%b %d %Y %X",$time),"%b %d %Y %H:%M"=>strftime("%b %d %Y %H:%M",$time),
    "%d. %b %Y %X"=>strftime("%d. %b %Y %X",$time),"%d. %b %Y %H:%M"=>strftime("%d. %b %Y %H:%M",$time),
    "%Y/%m/%d %X"=>strftime("%Y/%m/%d %X",$time),"%Y/%m/%d %H:%M"=>strftime("%Y/%m/%d %H:%M",$time));

// validation type of some vars
$validate=array('timelimit'=>"int",'del_time'=>"float",'email'=>"email");

// if data has been saved
if(isset($_POST['submit'])) {

    // generate global_conf.php
    $out="<?php\n\n/* This file is automatically generated and modified by phpMyBackupPro ".VERSION.".*/ \n\n";
    foreach($conf as $key=>$value) {
        if (in_array($value,$checkbox)) {
            if (isset($_POST[$value])) $status=1; else $status=0;
            $out.="\$CONF['".$value."']=\"".$status."\";\n";
        } else {
            $out.="\$CONF['".$value."']=\"".$_POST[$value]."\";\n";
        }
    }
    $out.="\n?>";

    // write global_conf.php
    if (@is_writable(GLOBAL_CONF)) {
        if (!$handle = @fopen(GLOBAL_CONF, "w")) {
            echo "<div class=\"red\">".C_OPEN." ".GLOBAL_CONF."</div>";
        } elseif (!@fwrite($handle, $out)) {
            echo "<div class=\"red\">".C_WRITE." ".GLOBAL_CONF."</div>";
        } else echo"<div class=\"green\">".C_SAVED."!</div>\n";
    } else {
        echo"<div class=\"red\">".GLOBAL_CONF." ".C_WRITEABLE."!</div>\n";
    }
    @fclose($handle);

    // include again because of possible changes
    include(GLOBAL_CONF);
}

foreach($CONF as $key=>$value) {

    // get $CONF in numeric array
    $result[]=$value;

    // validate
    if (array_key_exists($key,$validate)) {
        switch($validate[$key]) {
            case "int": if (!eregi("^[0-9]*$",$value)) echo "<div class=\"red\">'".array_search($key,$conf)."' ".C_WRONG_TYPE."</div>\n";
                break;
            case "float": if (!eregi("^[0-9]+.?[0-9]*$",$value)) echo "<div class=\"red\">'".array_search($key,$conf)."' ".C_WRONG_TYPE."</div>\n";
                break;
            case "email": if ($value||$CONF['email_use']) if (!eregi("^[a-zA-Z0-9_-]+(\.[a-zA-Z0-9\._-]+)*@([a-zA-Z0-9-]+\.)+([a-z]{2,4})$",$value)) echo "<div class=\"red\">'".array_search($key,$conf)."' ".C_WRONG_TYPE."</div>\n";
                break;
        }
    }
}

// if first use or no db-connection possible
if (!@mysql_connect($CONF['sql_host'],$CONF['sql_user'],$CONF['sql_passwd'])) echo "<div class=\"red\">".C_WRONG_SQL."</div><br>";

// print html form
echo"<form action=\"config.php\" method=\"post\">\n";

// print html table
$i=0;
echo "<table border=\"0\" cellspacing=\"2\" cellpadding=\"0\" width=\"100%\">\n";
echo "<colgroup>\n<col width=\"*\">\n<col width=\"100\">\n<col width=\"*\">\n</colgroup>\n";
foreach($conf as $key=>$value) {

    // for all $conf but language
    if ($value!="lang") {
        if (!($i%2)) echo "<tr>\n";
        echo "<td>\n";
            
        // decide if type is checbox, password, select or text
        if (in_array($value,$checkbox)) {
            if ($result[$i]) $status=" checked"; else $status="";
            echo $key.": </td><td><input type=\"checkbox\" name=\"".$value."\" value=\"".$result[$i++]."\" ".$status."><br>";
        } elseif (in_array($value,$password)) {
            echo $key.": </td><td><input type=\"password\" name=\"".$value."\" value=\"".$result[$i++]."\"><br>";
        } elseif (array_key_exists($value,$select)) {
            echo $key.": </td><td><select name=\"".$value."\">\n";
            foreach($select[$value] as $opt_no=>$print_value)
                if ($opt_no==$result[$i]) echo "<option value=\"".$opt_no."\" selected>".$print_value."</option>\n";
                    else echo "<option value=\"".$opt_no."\">".$print_value."</option>\n";
            echo "</select><br>";
            $i++;
        } else {
            echo $key.": </td><td><input type=\"text\" name=\"".$value."\" value=\"".$result[$i++]."\"><br>";
        }
        echo "</td>\n";
        if (!($i%2)) echo "</tr>\n"; else echo "<td>&nbsp;</td>";

    // if $conf is language print a select
    } else {
        
        // list all language files found in the language directory
        $handle=opendir('./language');
        while ($file = readdir($handle)) if (substr($file,-8,8)==".inc.php") $files[]=substr($file,0,strlen($file)-8);
        echo "<td>\n".$key.":</td>\n<td>\n<select name=\"".$value."\">\n";
        foreach($files as $file)
            if ($file==$CONF['lang']) echo "<option value=\"".$file."\" selected>".$file."</option>\n"; else echo "<option value=\"".$file."\">".$file."</option>\n";
        echo "</select>\n</td>\n</tr>\n";
    }
}
echo"<tr><td colspan=\"4\">\n<input name=\"submit\" type=\"submit\" value=\"".C_SAVE."\" class=\"button\">&nbsp;\n(".C_CHANGE.".)</td></tr>\n";
echo"</table>\n</form>";
printFooter();
?>
